package com.yice.webadmin.app.service.impl;

import cn.hutool.core.collection.CollUtil;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.github.pagehelper.Page;
import com.yice.common.core.base.dao.BaseDaoMapper;
import com.yice.common.core.base.service.BaseService;
import com.yice.common.core.object.CallResult;
import com.yice.common.core.object.MyRelationParam;
import com.yice.common.core.util.MyModelUtil;
import com.yice.common.sequence.wrapper.IdGeneratorWrapper;
import com.yice.webadmin.app.dao.ModelTaskMapper;
import com.yice.webadmin.app.model.ModelCompress;
import com.yice.webadmin.app.model.ModelEstimate;
import com.yice.webadmin.app.model.ModelTask;
import com.yice.webadmin.app.service.ModelCompressService;
import com.yice.webadmin.app.service.ModelEstimateService;
import com.yice.webadmin.app.service.ModelManageService;
import com.yice.webadmin.app.service.ModelTaskService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * 模型任务数据操作服务类。
 *
 * @author linking
 * @date 2023-04-13
 */
@Slf4j
@Service("modelTaskService")
public class ModelTaskServiceImpl extends BaseService<ModelTask, Long> implements ModelTaskService {

    @Autowired
    private ModelTaskMapper modelTaskMapper;
    @Autowired
    private ModelEstimateService modelEstimateService;
    @Autowired
    private ModelCompressService modelCompressService;
    @Autowired
    private ModelManageService modelManageService;
    @Autowired
    private IdGeneratorWrapper idGenerator;

    /**
     * 返回当前Service的主表Mapper对象。
     *
     * @return 主表Mapper对象。
     */
    @Override
    protected BaseDaoMapper<ModelTask> mapper() {
        return modelTaskMapper;
    }

    /**
     * 保存新增对象。
     *
     * @param modelTask 新增对象。
     * @return 返回新增对象。
     */
    @Override
    public ModelTask saveNew(ModelTask modelTask) {
        modelTaskMapper.insert(this.buildDefaultValue(modelTask));
        return modelTask;
    }

    /**
     * 利用数据库的insertList语法，批量插入对象列表。
     *
     * @param modelTaskList 新增对象列表。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public void saveNewBatch(List<ModelTask> modelTaskList) {
        if (CollUtil.isNotEmpty(modelTaskList)) {
            modelTaskList.forEach(this::buildDefaultValue);
            modelTaskMapper.insertList(modelTaskList);
        }
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public ModelTask saveNewWithRelation(ModelTask modelTask, JSONObject relationData) {
        this.saveNew(modelTask);
        this.saveOrUpdateOneToOneRelationData(modelTask, relationData);
        return modelTask;
    }

    /**
     * 更新数据对象。
     *
     * @param modelTask         更新的对象。
     * @param originalModelTask 原有数据对象。
     * @return 成功返回true，否则false。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public boolean update(ModelTask modelTask, ModelTask originalModelTask) {
        MyModelUtil.fillCommonsForUpdate(modelTask, originalModelTask);
        // 这里重点提示，在执行主表数据更新之前，如果有哪些字段不支持修改操作，请用原有数据对象字段替换当前数据字段。
        UpdateWrapper<ModelTask> uw = this.createUpdateQueryForNullValue(modelTask, modelTask.getTaskId());
        return modelTaskMapper.update(modelTask, uw) == 1;
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public boolean updateWithRelation(
            ModelTask modelTask, ModelTask originalModelTask, JSONObject relationData) {
        // modelTask 为空的时候，无需修改主表数据。
        if (modelTask != null && !this.update(modelTask, originalModelTask)) {
            return false;
        }
        this.saveOrUpdateOneToOneRelationData(originalModelTask, relationData);
        return true;
    }

    private void saveOrUpdateOneToOneRelationData(ModelTask modelTask, JSONObject relationData) {
        // 对于一对一新增或更新，如果主键值为空就新增，否则就更新，同时更新updateTime和updateUserId。
        ModelEstimate modelEstimate = relationData.getObject("modelEstimate", ModelEstimate.class);
        if (modelEstimate != null) {
            modelEstimate.setTaskId(modelTask.getTaskId());
            modelEstimateService.saveNewOrUpdate(modelEstimate,
                    modelEstimateService::saveNew, modelEstimateService::update);
        }
        ModelCompress modelCompress = relationData.getObject("modelCompress", ModelCompress.class);
        if (modelCompress != null) {
            modelCompress.setTaskId(modelTask.getTaskId());
            modelCompressService.saveNewOrUpdate(modelCompress,
                    modelCompressService::saveNew, modelCompressService::update);
        }
    }

    /**
     * 删除指定数据。
     *
     * @param taskId 主键Id。
     * @return 成功返回true，否则false。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public boolean remove(Long taskId) {
        if (modelTaskMapper.deleteById(taskId) == 0) {
            return false;
        }
        modelEstimateService.remove(taskId);
        modelCompressService.remove(taskId);
        return true;
    }

    /**
     * 当前服务的支持表为从表，根据主表的关联Id，删除一对多的从表数据。
     *
     * @param modelId 从表关联字段。
     * @return 删除数量。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public int removeByModelId(Long modelId) {
        ModelTask deletedObject = new ModelTask();
        deletedObject.setModelId(modelId);
        return modelTaskMapper.delete(new QueryWrapper<>(deletedObject));
    }

    /**
     * 获取单表查询结果。由于没有关联数据查询，因此在仅仅获取单表数据的场景下，效率更高。
     * 如果需要同时获取关联数据，请移步(getModelTaskListWithRelation)方法。
     *
     * @param filter  过滤对象。
     * @param orderBy 排序参数。
     * @return 查询结果集。
     */
    @Override
    public List<ModelTask> getModelTaskList(ModelTask filter, String orderBy) {
        return modelTaskMapper.getModelTaskList(filter, orderBy);
    }

    /**
     * 获取主表的查询结果，以及主表关联的字典数据和一对一从表数据，以及一对一从表的字典数据。
     * 该查询会涉及到一对一从表的关联过滤，或一对多从表的嵌套关联过滤，因此性能不如单表过滤。
     * 如果仅仅需要获取主表数据，请移步(getModelTaskList)，以便获取更好的查询性能。
     *
     * @param filter              主表过滤对象。
     * @param modelEstimateFilter 一对一从表过滤对象。
     * @param modelCompressFilter 一对一从表过滤对象。
     * @param orderBy             排序参数。
     * @return 查询结果集。
     */
    @Override
    public List<ModelTask> getModelTaskListWithRelation(ModelTask filter, ModelEstimate modelEstimateFilter, ModelCompress modelCompressFilter, String orderBy) {
        List<ModelTask> resultList =
                modelTaskMapper.getModelTaskListEx(filter, modelEstimateFilter, modelCompressFilter, orderBy);
        // 在缺省生成的代码中，如果查询结果resultList不是Page对象，说明没有分页，那么就很可能是数据导出接口调用了当前方法。
        // 为了避免一次性的大量数据关联，规避因此而造成的系统运行性能冲击，这里手动进行了分批次读取，开发者可按需修改该值。
        int batchSize = resultList instanceof Page ? 0 : 1000;
        this.buildRelationForDataList(resultList, MyRelationParam.normal(), batchSize);
        return resultList;
    }

    /**
     * 根据最新对象和原有对象的数据对比，判断关联的字典数据和多对一主表数据是否都是合法数据。
     *
     * @param modelTask         最新数据对象。
     * @param originalModelTask 原有数据对象。
     * @return 数据全部正确返回true，否则false。
     */
    @Override
    public CallResult verifyRelatedData(ModelTask modelTask, ModelTask originalModelTask) {
        String errorMessageFormat = "数据验证失败，关联的%s并不存在，请刷新后重试！";
        //这里是一对多的验证
        if (this.needToVerify(modelTask, originalModelTask, ModelTask::getModelId)
                && !modelManageService.existId(modelTask.getModelId())) {
            return CallResult.error(String.format(errorMessageFormat, "模型ID"));
        }
        return CallResult.ok();
    }

    private ModelTask buildDefaultValue(ModelTask modelTask) {
        if (modelTask.getTaskId() == null) {
            modelTask.setTaskId(idGenerator.nextLongId());
        }
        MyModelUtil.fillCommonsForInsert(modelTask);
        return modelTask;
    }
}
